'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _BaseInput$ATTRIBUTE_, _attributes;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseInput = function (_React$Component) {
    _inherits(BaseInput, _React$Component);

    function BaseInput(props) {
        _classCallCheck(this, BaseInput);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(BaseInput).call(this, props));
    }

    _createClass(BaseInput, [{
        key: 'getAttributes',
        value: function getAttributes(type) {
            var inputType = this.getInputType(type);
            if (!inputType) return;

            return BaseInput.CONFIG.attributes[inputType].concat(BaseInput.CONFIG.attributes.common);
        }
    }, {
        key: 'getStateAttributes',
        value: function getStateAttributes(type) {
            var attributes = this.getAttributes(type);
            return _lodash2.default.intersection(attributes, BaseInput.STATE_ATTRIBUTES);
        }
    }, {
        key: 'getInputType',
        value: function getInputType(type) {
            for (var key in BaseInput.ATTRIBUTE_TYPES) {
                if (BaseInput.ATTRIBUTE_TYPES[key].find(function (x) {
                    return x == type;
                })) return key;
            }
        }
    }]);

    return BaseInput;
}(_react2.default.Component);

exports.default = BaseInput;


BaseInput.INPUT_TYPES = {
    value: "value",
    checked: "checked"
};

BaseInput.TYPES = {
    text: BaseInput.INPUT_TYPES.value,
    email: BaseInput.INPUT_TYPES.value,
    password: BaseInput.INPUT_TYPES.value,
    radio: BaseInput.INPUT_TYPES.checked,
    checkbox: BaseInput.INPUT_TYPES.checked
};

BaseInput.ATTRIBUTE_TYPES = (_BaseInput$ATTRIBUTE_ = {}, _defineProperty(_BaseInput$ATTRIBUTE_, BaseInput.INPUT_TYPES.value, ['text', 'email', 'password']), _defineProperty(_BaseInput$ATTRIBUTE_, BaseInput.INPUT_TYPES.checked, ['radio', 'checkbox']), _BaseInput$ATTRIBUTE_);

BaseInput.CONFIG = {
    attributes: (_attributes = {}, _defineProperty(_attributes, BaseInput.INPUT_TYPES.value, ["value", "placeholder"]), _defineProperty(_attributes, BaseInput.INPUT_TYPES.checked, ["checked"]), _defineProperty(_attributes, 'common', ["disabled", "id", "name", "required", "type"]), _attributes)
};

BaseInput.STATE_ATTRIBUTES = ["value", "checked", "disabled", "required", "type"];