'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _BaseInput2 = require('./abstract/BaseInput');

var _BaseInput3 = _interopRequireDefault(_BaseInput2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_BaseInput) {
    _inherits(Input, _BaseInput);

    function Input(props) {
        _classCallCheck(this, Input);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Input).call(this, props));

        var stateAttributes = _this.getStateAttributes(props.type);
        if (!stateAttributes.length) {
            throw new Error("Invalid 'type' attribute!");
        }
        _this.state = _lodash2.default.pick(props, stateAttributes);

        _this._onMouseEnter = _this._onMouseEnter.bind(_this);
        _this._onMouseLeave = _this._onMouseLeave.bind(_this);
        _this._onChange = _this._onChange.bind(_this);
        return _this;
    }

    _createClass(Input, [{
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            var inputType = this.getInputType(this.state.type);
            if (this.state[inputType] != prevState[inputType]) {
                this.props.changeCallback();
            }
        }
    }, {
        key: '_onChange',
        value: function _onChange(e) {
            var inputType = this.getInputType(this.state.type);
            var stateValue = e.target[inputType];

            if (this.state[inputType] == stateValue) return;

            this.setState(_defineProperty({}, inputType, stateValue));
        }
    }, {
        key: '_onMouseEnter',
        value: function _onMouseEnter(e) {
            this.props.mouseEnterCallback();
        }
    }, {
        key: '_onMouseLeave',
        value: function _onMouseLeave(e) {
            this.props.mouseLeaveCallback();
        }
    }, {
        key: 'disabled',
        value: function disabled(v) {
            if (typeof v === 'undefined') {
                return this.state.disabled;
            } else {
                this.setState({ disabled: v });
            }
        }
    }, {
        key: 'required',
        value: function required(v) {
            if (typeof v === 'undefined') {
                return this.state.required;
            } else {
                this.setState({ required: v });
            }
        }
    }, {
        key: 'value',
        value: function value(v) {
            if (typeof this.state.value === 'undefined') throw new Error("Input type '" + this.state.type + "' doesn't support 'value'");

            if (typeof v === 'undefined') {
                return this.state.value;
            } else {
                this.setState({ value: v });
            }
        }
    }, {
        key: 'checked',
        value: function checked(v) {
            if (typeof this.state.checked === 'undefined') throw new Error("Input type '" + this.state.type + "' doesn't support 'checked'");

            if (typeof v === 'undefined') {
                return this.state.checked;
            } else {
                this.setState({ checked: v });
            }
        }
    }, {
        key: 'type',
        value: function type() {
            return this.state.type;
        }
    }, {
        key: 'render',
        value: function render() {
            var classes = (this.props.validate ? "validate " : "") + this.props.extraClass;
            var props = _lodash2.default.pick(this.props, this.getAttributes(this.state.type));
            return _react2.default.createElement('input', _extends({}, props, {
                type: this.state.type,
                disabled: this.state.disabled,
                required: this.state.required,
                onChange: this._onChange,
                onMouseEnter: this._onMouseEnter,
                onMouseLeave: this._onMouseLeave,
                className: classes }));
        }
    }]);

    return Input;
}(_BaseInput3.default);

exports.default = Input;


Input.displayName = "GenericInputElement";
Input.propTypes = {
    disabled: _react2.default.PropTypes.bool,
    required: _react2.default.PropTypes.bool,
    validate: _react2.default.PropTypes.bool,
    value: _react2.default.PropTypes.string,
    name: _react2.default.PropTypes.string,
    placeholder: _react2.default.PropTypes.string,
    id: _react2.default.PropTypes.string,
    type: _react2.default.PropTypes.oneOf(_lodash2.default.keys(_BaseInput3.default.TYPES)),
    extraClass: _react2.default.PropTypes.string,
    changeCallback: _react2.default.PropTypes.func,
    mouseEnterCallback: _react2.default.PropTypes.func,
    mouseLeaveCallback: _react2.default.PropTypes.func
};
Input.defaultProps = {
    disabled: false,
    required: false,
    validate: false,
    value: '',
    name: '',
    placeholder: '',
    id: '',
    type: 'text',
    extraClass: '',
    changeCallback: function changeCallback() {},
    mouseEnterCallback: function mouseEnterCallback() {},
    mouseLeaveCallback: function mouseLeaveCallback() {}
};